package ex2;

import java.util.ArrayList;
import java.util.Random;

public class Dealership {
    public double basePrice;
    public double baseSpeed;
    private ArrayList<Car> cars = new ArrayList<>();
    private Random random = new Random();

    public Dealership(double baseSpeed, double basePrice) {
        this.baseSpeed = baseSpeed;
        this.basePrice = basePrice;
    }

    /* TODO 2: Hide the cars produced by the dealership so that they cannot be altered */
    class Toyota extends Car{
        public Toyota() {
            super();
            this.type = CarType.GENERAL_PURPOSE;
            this.topSpeed = Dealership.this.baseSpeed;
            this.cost = Dealership.this.basePrice;
        }

    }

    class Audi extends Car{
        public Audi() {
            super();
            this.type = CarType.SPORTS;
            this.topSpeed = Dealership.this.baseSpeed * 1.2 * getMultiplier();
            this.cost = Dealership.this.basePrice * 1.5 * getMultiplier();
        }

    }

    /* TODO 3: Cut off all ties between Ferrari and Dealership */
    class Ferrari extends Car{
        public Ferrari() {
            super();
            this.type = CarType.RACING;
            this.topSpeed = Dealership.this.baseSpeed * 1.5 * getMultiplier();
            this.cost = Dealership.this.basePrice * 2.0 * getMultiplier();
        }

    }

    class Mustang extends Car{
        public Mustang() {
            super();
            this.type = CarType.MUSCLE;
            this.topSpeed = Dealership.this.baseSpeed * 1.1 * getMultiplier();
            this.cost = Dealership.this.basePrice * 1.7 * getMultiplier();
        }

    }

    /* TODO 4: Implement Tesla cars using anonymous inner classes and lambda functions*/


    /* Add multiplier up to 1.5x */
    private double getMultiplier() {
        return (1 + this.random.nextInt(49) / 100.0);
    }

    public Car getCar(CarType type) {
        Car car;
        switch (type) {
            case GENERAL_PURPOSE:
                car = new Toyota();
                break;
            case SPORTS:
                car = new Audi();
                break;
            case RACING:
                car = new Ferrari();
                break;
            case MUSCLE:
                car = new Mustang();
                break;
            default:
                System.out.println("[DEALERSHIP]CarType " + type + " not supported");
                return null;
        }

        this.cars.add(car);
        return car;
    }

}
